%{
int yylex();           
void yyerror (char *s);
extern int nums[];
extern int vnum;
int rval;
%}


%start expr


%%
 expr      :  expression { rval=$1; }
           ;

 expression:  expression logop add {
              switch($2) {
	      case 1:
		$$=$1&$3;
		break;
	      case 2:
		$$=$1|$3;
		break;
	      case 3:
		$$=$1^$3;
		break;
	      }
	    }
           |  add { $$=$1; }
           ;

 add       :  add plusop term {
              switch($2) {
	      case 6:
		$$=$1+$3;
		break;
	      case 7:
		$$=$1-$3;
		break;
	      }
	    }
           |  term { $$=$1; }
           ;

 term      :  term mulop unary {
              switch($2) {
	      case 4:
		$$=$1*$3;
		break;
	      case 5:
		$$=$1/$3;
		break;
	      }
	    }
           |  unary { $$=$1; }
           ;

 unary     : unop unary {    
             switch($1) {
	     case 8:
	       $$=(($2)>>8)&0xff;
	       break;
	     case 9:
	       $$=($2)&0xff;
	       break;
	     case 10:
	       $$=-($2);
	       break;
	     }
	   }
           | not { $$=$1; }
           ;

 not       : '!' not { $$=!$2; }
           | factor  { $$=$1; }
           ;
   
 factor    :  '[' expression ']' {$$=$2;}
           |  'N' {$$=nums[vnum++]; }
           ;

 logop     :  '&' {$$=1; }
           | '|'  {$$=2; }
           | '^'  {$$=3; }
           ;

 mulop     :  '*' {$$=4; }
           | '/'  {$$=5; }
           ;

 plusop    : '+'  {$$=6; }
           | '-'  {$$=7; }
           ;

 unop      : '>' {$$=8; }
           | '<' {$$=9; }
           | '-' {$$=10; }
           | 'D' {$$=11; }
           | 'R' {$$=12; }
           ;

/* compop     : '='
              | '>'
	      | '<'
	      | '<='
	      | '>='
	      | '<>' ; */
%%

/* Called by the parser (yyparse) when an error is found.  We do nothing here,
   but rely upon the error recovery that we have built in. */

void yyerror (char *s) {
}
